//Little 2D game.
///////////////////////////////
#include <acknex.h>
#include <default.c>

///////////////////////////////
var active = 1; //Teleport state
var health = 100; //Health state
var card = 0; //card acquired

var healthx = 0; //Elude asukoht akna suhtes.
var spd = 2.5; //moving speed
var alarm;

var add_on;
var change = 0; //Kas relva vahetati?
var g_type = 0; //Relv kes (samuti gun[..] index)
//relvad. Esimene[] on relva tp. [1] on salve mahtuvus: 1-sest seal 1 number sees. Indeks sellel on aga ikka 0
var gun[2][4]; //define multidimensional array

var init_array_startup()   //Giving values to addresses
{
   gun[0][0] = 5; //Konstant :: Salve kuule mahub.
   gun[0][1] = 5;  //Palju kuule hetkel salves
   gun[0][2] = 25; //Kuule kokku
   gun[0][3] = -0.3; //Laskmiskiirus
   gun[1][0] = 10;//Konstant :: Salve kuule mahub
   gun[1][1] = 10; //Kuule salves
   gun[1][2] = 50; //Kuule kokku
   gun[1][3] = -0.1; //Laskmiskiirus
}

var bullets = 0; //Palju kuule on hetkel salves
var cartridge = 0; //Mitu kuuli on salvedes kokku.
var panel_count = -1; //Loeb paneele, mis bul_panel ra kaotada!
PANEL* bul_panel[10]; //paneelide pointerid
//var bul_count = 0; //neccesary to identify individual bullets!

STRING* str_count = "";
STRING* str_bullets = "";
STRING* str_dir = "";
STRING* str_mousex = "";
STRING* str_mousey = "";
STRING* str_addon = "";

BMAP* teleport = "teleport.pcx";
BMAP* lgt_active = "lgt_active.png";
BMAP* lgt_out = "lgt_out.png";
BMAP* lgt_red = "lgt_out_red.png";

BMAP* bg_level = "bg_indust.pcx";
BMAP* bg_hud = "hud.png";

BMAP* hud_health = "health.pcx";
BMAP* hud_card = "hud_card.png";
BMAP* hud_bullet = "bullet_ico.png";

//BMAP* s_card = "card.png";
//BMAP* s_medkit = "medkit.pcx";

BMAP* s_pl_pistol_sh = "pl_pistol_sh.png";
BMAP* s_pl_pistol = "pl_pistol.pcx";
BMAP* s_pl_autom_sh = "pl_autom_sh.png";
BMAP* s_pl_autom = "pl_autom.pcx";

BMAP* s_bullet = "bullet.bmp";


//Tagataust
PANEL* p_level =
{
   bmap = bg_level;
   layer = 0;
   flags = SHOW;
}

//Teleporteri pilt
PANEL* p_teleport =
{
   pos_x = 500;
   pos_y = 100;
   layer = 1;
   bmap = teleport;
   flags = SHOW | OVERLAY; //Eemaldame musta tagtausta
}

//Valgusti
PANEL* p_tele_light =
{
   pos_x = 0;
   pos_y = 0;
   layer = 2;
   bmap = lgt_red;
   flags = SHOW;
}

//HUD---------------------------

PANEL* p_hud =
{
   bmap = bg_hud;
   layer = 100; //Teiste peal.
   flags = SHOW;
}

PANEL* p_health =
{
   pos_x = 21;
   pos_y = 6;
   window(0,0, 113, 13, hud_health, healthx, 0);
   layer = 99; //allapool HUD-i
   flags = SHOW;
}

PANEL* p_hud_card =
{
   pos_x = 197;
   pos_y = 4;
   layer = 101; //bg_hud peal oleks.
   bmap = hud_card;
   //flags = SHOW;
}

PANEL* p_info =
{
   pos_x = 345;
   pos_y = 15;
   layer = 101;
   digits(0,0,"%.0f",*,1,cartridge); 
   flags = SHOW;
}
/*
TEXT* dbg_count =
{
   pos_x = 0;
   pos_y = 100;
   string("panel_count: ", str_count);
   string("bullets: ", str_bullets);
   string("mouse_x:", str_mousex, "mouse_y: ", str_mousey);
   string("direction: ", str_dir);
   string("cartridge: ", str_addon);
   flags = SHOW;
}
*/
//------------------------------


PANEL* p_player =
{
   pos_x = 30;
   pos_y = 30;
   layer = 3;
   //23
   center_x = 23;
   center_y = 23; 
   //needle(0, 0, s_pl_pistol, 23,23, 360, 0, 360, direction);   
   bmap = s_pl_pistol;
   flags = SHOW | OVERLAY;
}

PANEL* p_pl_shadow =
{
   //x,y ajab main()-is p_playeri oma taga.
   layer = 2;
   center_x = 23;
   center_y = 23;
   bmap = s_pl_pistol_sh;
   flags = SHOW | TRANSLUCENT;
   alpha = 25;
}

//FUNCTIONS---------------------------------
//Valguse muutja
function light_change()
{
   while(1) //Kui paneel on aktiivne
   {
      switch (active) //Kime lbi staatused
      { 
         case 0: //Kui deaktiveeritud
            if (p_tele_light.bmap == lgt_out) //Kui pilt vastav
            { 
            p_tele_light.bmap = lgt_red;
            }else{
            p_tele_light.bmap = lgt_out;
            }
         break;
         default:
            p_tele_light.bmap = lgt_active;
      }
   wait(-0.2);
   }
}

function reload()
{
   cartridge = gun[g_type][2]; //Kuule kokku     
   bullets = gun[g_type][1]; //hetkel salves     
   
   if (cartridge > 0) //Kui salves kuule on 
   {
      if (change == 0) //Kui relva ei vahetatud!
      {   
         add_on = (gun[g_type][0] - bullets); //arvutame mitu kuuli salve panna, kui salves nt ka kuulid veel alles on
         
         if (cartridge < add_on) //Kui salve on juhuslikult vhem kuule kui salve juurde oleks vaja panna
         { 
            add_on = cartridge; //lisame salve, mis jrele jnud
         }
      
         cartridge -= add_on; //Vtame kuulid salvest ra, mis juurde lisatakse.
         bullets += add_on; //Lisame kuule. 
         gun[g_type][2] = cartridge;
         gun[g_type][1] = bullets;
      
      
      }else{ //Kui relva vahetati, jtame kuulide lisamise vahele.
      //gun[g_type][1] on laskmise jrel jnud muutmatuks ja seda kasutame tsklis kuulide uuesti tagasitoomiseks HUD-ile. 
         change = 0; //nullime muutuja.
      }

   }
   //Loome paneelid.
   var a;  
   for (a=panel_count+1;  a < gun[g_type][1]; a+=1)//panel_count+1 so I could reload in a middle.
   {
      bul_panel[a] = pan_create(NULL, 101);
      bul_panel[a].bmap = hud_bullet; //bmap_create("bullet_ico.png");
      bul_panel[a].pos_x = 320 - 9*a; 
      bul_panel[a].pos_y = 3;
      set(bul_panel[a], SHOW);
      panel_count = a; 
   }
}

//Relva vahetades kustutab vana info
function reset_bullets()
{
   var a;
   for (a=-1; a < gun[g_type][1]; a+=1)
   {
      ptr_remove(bul_panel[a]);
   }
   panel_count = -1;
   change = 1; //relva vahetati!
}
/*
function move_bullet()
{
	var a;
	for (a=0; a<bul_count; a+=1)
	{
		p_bullet[a].pos_x += spd * cos(-p_bullet[a]].angle) * time_step;
		p_bullet[a].pos_y += spd * sin(-p_bullet[a]].angle) * time_step;
		if ((p_bullet.pos_x > p_hud.size_x) | (p_bullet.pos_x < 0) | (p_bullet.pos_y > p_hud.size_y) | (p_bullet.pos_y < 0))
			{
				ptr_remove(p_bullet[a]);
			}
	wait(1);
	}
}

function create_bullet()
{
	var p_bullet[300];
	p_bullet[bul_count] = pan_create("bmap = s_bullet; pos_x = p_player.pos_x; pos_y = p_player.pos_y; angle = p_player.angle; flags = SHOW;", 4);
	//p_bullet[bul_count].bmap = s_bullet; //bmap_create("bullet_ico.png");
   move_bullet();
}*/

function shoot()
{
   while (1)
   {
   while (mouse_left)
   {
      if ((gun[g_type][1] > 0)) 
      {
      	//bul_count++;
      	//create_bullet; //creates a bullet and gives a motion to it.
         gun[g_type][1]--; //Kuule 1 vrra maha
         ptr_remove(bul_panel[panel_count]);
         panel_count--; //paneel 1 vrra maha
      } 
   wait(gun[g_type][3]);
   }
   wait(1);
   }
}

function change_gun()
{
   reset_bullets(); //Kustutab n vana info.
      if (g_type ==0)
      { 
         g_type = 1; 
         p_player.bmap = s_pl_autom; 
         p_pl_shadow.bmap = s_pl_autom_sh;
      }else{
         g_type = 0;
         p_player.bmap = s_pl_pistol; 
         p_pl_shadow.bmap = s_pl_pistol_sh;
      }
   reload(); //Vtame uued kuulid vastavalt muutustele  
}

function health_upd()
{
   healthx = (113 * health)/100;
   healthx = 113 - healthx;
}

function card_upd()
{
   if (card == 1) //Kui aktiivne
   {
      //p_hud_card.flags |= SHOW;
      set(p_hud_card, SHOW);
   }else{
      //p_hud_card.flags &= ~SHOW; //Muudame nhtamatuks
      reset(p_hud_card, SHOW);
   }
}

function point_direction(x1, y1, x2, y2)
{
   float d;
   //Needed to place - before atan2 in order to get correct panel rotation. =======!!========!!======
   d = -atan2(y2-y1, x2-x1) * 180/3.14159265; //can't use "pi".... :S
   return(d);
}

//PLAYER MOVEMENT---------------------------------
function pl_move_abs()
{
   p_player.pos_x += spd * (key_d - key_a) * time_step; 
   p_player.pos_y += spd * (key_s - key_w) * time_step;
   //p_player.pos_x += spd * (key_q - key_e) * cos(p_player.angle) * time_step;
   //p_player.pos_y += spd * (key_q - key_e) * sin(p_player.angle) * time_step;
}

function pl_move_rel()
{
   //In order to get relative movement I had to place - before angles  ======!!===========!!=========
   //to compensate false image rotation and correct moving direction....
   p_player.pos_x += spd * (key_w - key_s) * cos(-p_player.angle) * time_step;
   p_player.pos_y += spd * (key_w - key_s) * sin(-p_player.angle) * time_step;
}

//MAIN GAME========================================================================================
function main()
{
   video_mode = 6;
   d3d_autotransparency = 1; //takes the upper left pixel to be transparent.
   mouse_mode = 4; //So that mouse_pos would automatically change
   
   level_load(""); // load an empty level
   wait(2);
   
   reload(); //reloads gun at a beginning
   
   //Liigutame valgustid Telepordi peale!
   p_tele_light.pos_x = p_teleport.pos_x;
   p_tele_light.pos_y = p_teleport.pos_y;
   light_change();
   
   shoot();
   
   while(1)
   {      
      p_player.angle = point_direction(p_player.pos_x+23, p_player.pos_y+23, mouse_pos.x, mouse_pos.y);
      //Move shadow with player
      p_pl_shadow.pos_x = p_player.pos_x + 6;
      p_pl_shadow.pos_y = p_player.pos_y + 6;
      p_pl_shadow.angle = p_player.angle;
      
      pl_move_abs(); //Absoluutne liikumine  //Change to   _rel  to use half done relative movement
      on_q = change_gun; //vahetab relva
      
      health_upd();
      card_upd();
      
      
      on_r = reload;
/*
      //debug reasons
      str_for_num(str_count, panel_count);
      str_for_num(str_bullets, gun[g_type][1]);
      str_for_num(str_dir, p_player.angle);
      str_for_num(str_addon, gun[g_type][2]);
      str_for_num(str_mousex, mouse_pos.x);
      str_for_num(str_mousey, mouse_pos.y);
*/
   wait(1);
   }
}

